from game_main import Map
from sender import Sender
import time as t
from game_main import get_tick

gamerun = 1
game_state = 1

import threading
#from msvcrt import getch

class _GetchUnix:
    def __init__(self):
        import tty, sys

    def __call__(self):
        import sys, tty, termios
        fd = sys.stdin.fileno()
        old_settings = termios.tcgetattr(fd)
        try:
            tty.setraw(sys.stdin.fileno())
            ch = sys.stdin.read(1)
        finally:
            termios.tcsetattr(fd, termios.TCSADRAIN, old_settings)
        return ch


getch = _GetchUnix()


class ThreadClass(threading.Thread):
	def __init__(self,map):
		threading.Thread.__init__(self)
		self.m = map
	def run(self):
		global gamerun
		while gamerun:
			z = getch()
			# escape key to exit
			if ord(z) == 27:
				break
			if z == 's':
				self.m.PlayerPlusXY( 1 , 0 )
			if z == 'w':
				self.m.PlayerPlusXY( -1 , 0 )
			if z == 'a':
				self.m.PlayerPlusXY( 0 , -1 )
			if z == 'd':
				self.m.PlayerPlusXY( 0 , 1 )
			#print z
		gamerun = 0
		
m = Map( 'map1.txt' , 'pat1.txt' )
m_win = Map( 'map_win.txt' , 'pat_null.txt' )
m_lost = Map( 'map_lost.txt' , 'pat_null.txt' )
s = Sender()
m.start()

tra = ThreadClass( m )
tra.start()

while( gamerun == 1 ):
	tick = get_tick()
	
	if( game_state == 1 ):
		if tick - dtmp > 3000 :
			m.start()
			game_state = 0
		continue
	if( game_state == 2 ):
		if tick - dtmp > 3000 :
			m.start()
			game_state = 0
		continue
	
	m.update( tick )
	s.PassMap( m )
	if m.PlayerState() != 0 :
		#m.endRender()
		game_state = 2
		dtmp = tick
		s.PassMap( m_lost )
		#m.start()
		#m.startRender()
	if( (m.px != 1 or m.py != 0) and m.PlayerState() == 0 ):
		if( m.px == 0 or m.py == 0 or m.px == m.lx-1 or m.py == m.ly-1 ):
			game_state = 1 #WIN
			dtmp = tick
			s.PassMap( m_win)
	k = s.GetSwitch()
	xp = 0
	yp = 0
	if( k[0] == 1 ):
		xp = xp - 1
	if k[1] == 1 :
		xp = xp + 1
	if k[2] == 1 :
		yp = yp -1
	if k[3] == 1:
		yp = yp +1
	m.PlayerPlusXY( xp ,yp )
	t.sleep(0.1)
	
