from practicum import McuBoard
from game_main import Map

RQ_SET_MAPX0    = 3
RQ_SET_MAPX2	= 4
RQ_SET_MAPX4	= 5
RQ_GET_SWITCH_CON   = 6

#class Sender:
class Sender(McuBoard):
	def __init__(self):
		McuBoard.__init__(self)
		self.odir_x = 1
		self.odir_y = 1
		self.sxx0 = [-1,-1]
		self.sxx2 = [-1,-1]
		self.sxx4 = [-1,-1]
	def testFn(self):
		self.usb_write( 8 )
	def GetSwitch(self):
		#up down left right
		v = self.usb_read( RQ_GET_SWITCH_CON , length=1 )[0]
		sup = v%2;
		v = v/2;
		sdown = v%2;
		v = v/2;
		sleft = v%2;
		v = v/2;
		sright = v%2;
		ret = ( sup , sdown , sleft , sright )
		return ret
	def PassMap(self,map):
		px = map.px
		py = map.py
		lx = map.lx
		ly = map.ly
		midx = 0
		midy = 0
		if self.odir_x > 0 :
			midx = 2
		else :
			midy = 3
		if self.odir_y > 0 :
			midy = 2
		else :
			midy = 3
		start_x = map.px - midx
		start_y = map.py - midy
		if start_x < 0 :
			start_x = 0
		if start_y < 0 :
			start_y = 0
		if start_x + 5 >= lx :
			start_x = lx - 6
		if start_y + 5 >= ly :
			start_y = ly - 6
		map.startRender()
		for i in range(6):
			tmp = ''
			for j in range(6):
				tmp = tmp + map.dataTmp[start_x+i][start_y+j]
			print tmp
		sm = [0,0]
		for i in range(2):
			p = 1
			for j in range(6):
				if map.dataTmp[start_x+i][start_y+j] == 'O' or map.dataTmp[start_x+i][start_y+j] == 'B':
					sm[i%2] = sm[i%2] + p*2
				elif map.dataTmp[start_x+i][start_y+j] != '.' :
					sm[i%2] = sm[i%2] + p*1
				p = p * 3
		#print " SUM OF MAPX0 -> " + str(sm)
		
		if( sm[0] != self.sxx0[0] or sm[1] != self.sxx0[1] ):
			self.sxx0[0] = sm[0]
			self.sxx0[1] = sm[1]
			self.usb_write( RQ_SET_MAPX0 , sm[0] , sm[1] )
		sm = [0,0]
		for i in range(2,4):
			p = 1
			for j in range(6):
				#if map.dataTmp[start_x+i][start_y+j] != '.' :
				#	sm[i%2] = sm[i%2] + p
				#p = p * 2
				if map.dataTmp[start_x+i][start_y+j] == 'O' or map.dataTmp[start_x+i][start_y+j] == 'B':
					sm[i%2] = sm[i%2] + p*2
				elif map.dataTmp[start_x+i][start_y+j] != '.' :
					sm[i%2] = sm[i%2] + p*1
				p = p * 3
		#print " SUM OF MAPX2 -> " + str(sm)
		if( sm[0] != self.sxx2[0] or sm[1] != self.sxx2[1] ):
			self.sxx2[0] = sm[0]
			self.sxx2[1] = sm[1]
			self.usb_write( RQ_SET_MAPX2 , sm[0] , sm[1] )
		sm = [0,0]
		for i in range(4,6):
			p = 1
			for j in range(6):
				#if map.dataTmp[start_x+i][start_y+j] != '.' :
				#	sm[i%2] = sm[i%2] + p
				#p = p * 2
				if map.dataTmp[start_x+i][start_y+j] == 'O' or map.dataTmp[start_x+i][start_y+j] == 'B':
					sm[i%2] = sm[i%2] + p*2
				elif map.dataTmp[start_x+i][start_y+j] != '.' :
					sm[i%2] = sm[i%2] + p*1
				p = p * 3
		#print " SUM OF MAPX4 -> " + str(sm)
		if( sm[0] != self.sxx4[0] or sm[1] != self.sxx4[1] ):
			self.sxx4[0] = sm[0]
			self.sxx4[1] = sm[1]
			self.usb_write( RQ_SET_MAPX4 , sm[0] , sm[1] )
		map.endRender()
		return
		#pass
